Index: channel.c
===================================================================
--- channel.c	(revision 9319)
+++ channel.c	(revision 9323)
@@ -2075,7 +1996,9 @@
 	}
 	/* Wait full interval */
 	rms = *ms;
-	if (whentohangup) {
+	if (whentohangup > LONG_MAX / 1000)		/* prevent overflows */
+		whentohangup = 0;
+	else if (whentohangup) {
 		rms = whentohangup * 1000;              /* timeout in milliseconds */
 		if (*ms >= 0 && *ms < rms)		/* original *ms still smaller */
 			rms =  *ms;
